## ros-humble-dynamixel-workbench-toolbox 2.2.3

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 3.5)
project(dynamixel_workbench_toolbox)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(MSVC)
  add_compile_definitions(
    _USE_MATH_DEFINES
  )
endif()

################################################################################
# Find and load build settings from external packages
################################################################################
find_package(ament_cmake REQUIRED)
find_package(dynamixel_sdk REQUIRED)
find_package(rclcpp REQUIRED)

################################################################################
# Declare ROS messages, services and actions
################################################################################

################################################################################
# Build
################################################################################
include_directories(
  include
)

set(dependencies_lib
  "dynamixel_sdk"
  "rclcpp"
)

set(LIB_NAME "dynamixel_workbench_toolbox")

add_library(${LIB_NAME} SHARED
  src/${PROJECT_NAME}/dynamixel_item.cpp
  src/${PROJECT_NAME}/dynamixel_driver.cpp
  src/${PROJECT_NAME}/dynamixel_tool.cpp
  src/${PROJECT_NAME}/dynamixel_workbench.cpp
)
ament_target_dependencies(${LIB_NAME} ${dependencies_lib})

################################################################################
# Install
################################################################################
install(TARGETS ${LIB_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include/
)

################################################################################
# Test
################################################################################

################################################################################
# Macro for ament package
################################################################################
ament_export_include_directories(include)
ament_export_dependencies(dynamixel_sdk)
ament_export_dependencies(rclcpp)
ament_export_libraries(${LIB_NAME})
ament_package()

=== debian/changelog ===
ros-humble-dynamixel-workbench-toolbox (2.2.3-1jammy) jammy; urgency=high

  * ROS2 release (Foxy, Galactic, Humble)
  * fix variable length warning (#364)
  * Contributoers: Kenji Brameld, Will Son

 -- Will Son <willson@robotis.com>  Wed, 05 Oct 2022 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (2.2.2-1jammy) jammy; urgency=high

  * ROS2 package update only
  * Support 2XC430 on ROS2 (#342)
  * Support X330 series, XW series on ROS2 (#350)
  * New features(Startup Config, Backup Ready) updated in the Control Table Item list
    Start Config : https://emanual.robotis.com/docs/en/dxl/x/xm430-w210/#startup-configuration
    Backup Ready : https://emanual.robotis.com/docs/en/dxl/x/xm430-w210/#backup-ready
  * Contributors: Richard Osterloh, Yoshito Okada, Will Son

 -- Will Son <willson@robotis.com>  Mon, 24 Jan 2022 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (2.1.0-1jammy) jammy; urgency=high

  * Removed single_manager and single_manager_gui
  * Added XH540, PRO (A Firmware), RH_P12_RN, RH_P12_RN (A Firmware)
  * Contributors: Ryan Shim

 -- Will Son <willson@robotis.com>  Mon, 03 Jun 2019 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (2.0.0-1jammy) jammy; urgency=high

  * added YAML configuration for Dynamixel
  * supported position control mode, current based position control mode through Joint Trajectory Message
  * supported velocity control mode through Twist Message
  * reduced memory usage(Contribute by @KurtE)
  * updated API for sync, bulk instruction
  * updated control period (default is 10ms)
  * supported Linux, macos
  * supported Pro+
  * supported DynamixelSDK(after v.3.6.2)
  * supported OpenManipulator
  * Contributors: Darby Lim, KurtE, Pyo

 -- Will Son <willson@robotis.com>  Thu, 03 Jan 2019 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (1.0.0-1jammy) jammy; urgency=high

  * upgraded read time #162
  * added Dynamixel PRO information #162
  * added readRegister function
  * update dxl pro info
  * update proInfo func
  * modified max radian position
  * Contributors: Darby Lim, Pyo, Taehun Lim

 -- Will Son <willson@robotis.com>  Thu, 19 Jul 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.3.1-1jammy) jammy; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Sun, 03 Jun 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.3.0-1jammy) jammy; urgency=high

  * added getProtocolVersion()
  * changed max_dxl_deries_num
  * merged pull request #152 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/152> #151 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/151> #149 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/149> #132 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/132>
  * Contributors: Darby Lim, Pyo

 -- Will Son <willson@robotis.com>  Thu, 31 May 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.2.4-1jammy) jammy; urgency=high

  * changed package.xml to format v2
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Mon, 19 Mar 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.2.3-1jammy) jammy; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Thu, 08 Mar 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.2.2-1jammy) jammy; urgency=high

  * modified the CI configurations (#117 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/117>)
  * modified the CMakeLists.txt to fix wrong path (ros/rosdistro#17019 <https://github.com/ros/rosdistro/pull/17019>)
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Tue, 27 Feb 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.2.1-1jammy) jammy; urgency=high

  * modified the CMakeLists.txt to fix wrong path
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Wed, 21 Feb 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.2.0-1jammy) jammy; urgency=high

  * added conver function to PRO user
  * added dxl_info_cnt init function
  * added compatibility for different protocol
  * added static
  * added convert function
  * added baudrate sorting
  * added all dynamixel series
  * added RX-10
  * added millis
  * added init dynamixel example
  * added setting for packet handler
  * added monitor example
  * added item
  * added dynamixel_item
  * added toolbox_ros and modified arduino path
  * added linux build and example
  * added begin and getprotocolversion function
  * modified linux version
  * modified description
  * modified model_info
  * modified variable range
  * modified setTools function
  * modified sync function
  * modified merge conflict
  * modified variable name
  * modified reset function
  * modified function name and return variable name
  * modified name of return var
  * modified item name
  * modified reset function
  * modified item name (added underscore)
  * modified function name
  * modified function for ROS depend
  * modified function to make space
  * modified begin function to reduce storage space
  * modified MX (2.0) protocol setting bug
  * modified example
  * modified sync and bulk comm
  * modified lib
  * modified begin
  * modified variable
  * modified begin function
  * modified joint and wheel mode
  * modified variable name
  * modified begin function
  * modified set function
  * modified dynamixel item
  * modified scan function
  * modified folder tree
  * modified dynamixel_tool
  * modified toolbox structure
  * modified .device and modified funtion for opencm and opencr
  * modified ifdef
  * modified get file
  * modified arduino version
  * modified get device in arduino
  * fixed reset bug
  * deleted dead code
  * deleted empty space
  * deleted xl define
  * deleted debug code and update ping func
  * test OpenCM
  * Contributors: Darby Lim, Yoonseok Pyo

 -- Will Son <willson@robotis.com>  Sun, 18 Feb 2018 15:00:00 -0000

ros-humble-dynamixel-workbench-toolbox (0.1.9-1jammy) jammy; urgency=high

  * modified dependency
  * Contributors: Darby Lim



=== debian/control ===
Source: ros-humble-dynamixel-workbench-toolbox
Section: misc
Priority: optional
Maintainer: Will Son <willson@robotis.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-dynamixel-sdk, ros-humble-rclcpp, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/dynamixel_workbench_toolbox
Standards-Version: 3.9.2

Package: ros-humble-dynamixel-workbench-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-dynamixel-sdk, ros-humble-rclcpp, ros-humble-ros-workspace
Description: This package is composed of 'dynamixel_item', 'dynamixel_tool', 'dynamixel_driver' and 'dynamixel_workbench' class.
 The 'dynamixel_item' is saved as control table item and information of DYNAMIXEL. The 'dynamixel_tool' class loads its by model number of DYNAMIXEL. The 'dynamixel_driver' class includes wraped function used in DYNAMIXEL SDK. The 'dynamixel_workbench' class make simple to use DYNAMIXEL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-dynamixel-workbench-toolbox//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
